Gentoo Websites Logo
Go to: Gentoo Home Documentation Forums Lists Bugs Planet Store Wiki Get Gentoo!

Bug 351173

Summary: x11-misc/xscreensaver-5.12 has a memory leak in gltext
Product: Gentoo Linux Reporter: Brian Beardall <brian>
Component: Current packagesAssignee: Desktop Misc. Team <desktop-misc>
Status: RESOLVED FIXED    
Severity: enhancement CC: mtasaka
Priority: High    
Version: unspecified   
Hardware: All   
OS: Linux   
URL: http://pkgs.fedoraproject.org/gitweb/?p=xscreensaver.git;a=commitdiff;h=32e89dc222df24a357f296e79bea1ffbab6d3477
Whiteboard:
Package list:
Runtime testing required: ---

Description Brian Beardall 2011-01-09 03:24:34 UTC
gltext which is part of xscreensaver is leaking memory and causing the OOM killer to run. gltext was using 11G of virtual memory space when it got killed. I am running this with the nvidia driver OpenGL version string: 3.3.0 NVIDIA 260.19.29 with the graphics card OpenGL renderer string: GeForce 9600 GT/PCI/SSE2.

gnome-power-man invoked oom-killer: gfp_mask=0x201da, order=0, oom_adj=0, oom_score_adj=0
gnome-power-man cpuset=/ mems_allowed=0
Pid: 13617, comm: gnome-power-man Tainted: P            2.6.37-gentoo #3
Call Trace:
 [<ffffffff81478cc0>] ? _raw_spin_unlock+0x10/0x30
 [<ffffffff810b1e22>] ? dump_header+0xa2/0x250
 [<ffffffff8103c679>] ? get_parent_ip+0x9/0x20
 [<ffffffff8103c679>] ? get_parent_ip+0x9/0x20
 [<ffffffff81478fee>] ? _raw_spin_lock+0xe/0x30
 [<ffffffff810b1cc2>] ? find_lock_task_mm+0x32/0x80
 [<ffffffff81478c82>] ? _raw_spin_unlock_irqrestore+0x12/0x40
 [<ffffffff810b235e>] ? oom_kill_process+0x9e/0x2b0
 [<ffffffff810b289d>] ? out_of_memory+0xed/0x240
 [<ffffffff810b68af>] ? __alloc_pages_nodemask+0x6df/0x6f0
 [<ffffffff810b8530>] ? __do_page_cache_readahead+0xf0/0x240
 [<ffffffff810b869c>] ? ra_submit+0x1c/0x30
 [<ffffffff810b035d>] ? filemap_fault+0x48d/0x4c0
 [<ffffffff810c8352>] ? __do_fault+0x52/0x5a0
 [<ffffffff8137a0b0>] ? sock_aio_write+0x0/0x1a0
 [<ffffffff810c9ac0>] ? handle_mm_fault+0x1b0/0xb60
 [<ffffffff8102d046>] ? do_page_fault+0x146/0x430
 [<ffffffff8106a281>] ? ktime_get_ts+0x61/0xd0
 [<ffffffff811002b9>] ? poll_select_set_timeout+0x89/0xa0
 [<ffffffff814796cf>] ? page_fault+0x1f/0x30
Mem-Info:
DMA per-cpu:
CPU    0: hi:    0, btch:   1 usd:   0
CPU    1: hi:    0, btch:   1 usd:   0
DMA32 per-cpu:
CPU    0: hi:  186, btch:  31 usd:  30
CPU    1: hi:  186, btch:  31 usd: 157
Normal per-cpu:
CPU    0: hi:  186, btch:  31 usd:  30
CPU    1: hi:  186, btch:  31 usd: 148
active_anon:700734 inactive_anon:257085 isolated_anon:0
 active_file:187 inactive_file:248 isolated_file:0
 unevictable:0 dirty:0 writeback:402 unstable:0
 free:6958 slab_reclaimable:2968 slab_unreclaimable:5615
 mapped:1007 shmem:8 pagetables:10915 bounce:0
DMA free:15836kB min:28kB low:32kB high:40kB active_anon:0kB inactive_anon:0kB active_file:0kB inactive_file:0kB unevictable:0kB isolated(anon):0kB isolated(file):0kB present:15684kB mlocked:0kB dirty:0kB writeback:0kB mapped:0kB shmem:0kB slab_reclaimable:0kB slab_unreclaimable:8kB kernel_stack:0kB pagetables:0kB unstable:0kB bounce:0kB writeback_tmp:0kB pages_scanned:0 all_unreclaimable? yes
lowmem_reserve[]: 0 3000 4010 4010
DMA32 free:9988kB min:6048kB low:7560kB high:9072kB active_anon:2366352kB inactive_anon:591636kB active_file:168kB inactive_file:300kB unevictable:0kB isolated(anon):0kB isolated(file):0kB present:3072160kB mlocked:0kB dirty:0kB writeback:564kB mapped:3560kB shmem:0kB slab_reclaimable:2184kB slab_unreclaimable:3776kB kernel_stack:168kB pagetables:11284kB unstable:0kB bounce:0kB writeback_tmp:0kB pages_scanned:722 all_unreclaimable? yes
lowmem_reserve[]: 0 0 1010 1010
Normal free:2008kB min:2036kB low:2544kB high:3052kB active_anon:436584kB inactive_anon:436704kB active_file:580kB inactive_file:692kB unevictable:0kB isolated(anon):0kB isolated(file):0kB present:1034240kB mlocked:0kB dirty:0kB writeback:1044kB mapped:468kB shmem:32kB slab_reclaimable:9688kB slab_unreclaimable:18676kB kernel_stack:2816kB pagetables:32376kB unstable:0kB bounce:0kB writeback_tmp:0kB pages_scanned:2015 all_unreclaimable? yes
lowmem_reserve[]: 0 0 0 0
DMA: 1*4kB 1*8kB 1*16kB 0*32kB 1*64kB 1*128kB 1*256kB 0*512kB 1*1024kB 1*2048kB 3*4096kB = 15836kB
DMA32: 1187*4kB 43*8kB 40*16kB 3*32kB 1*64kB 0*128kB 0*256kB 0*512kB 0*1024kB 0*2048kB 1*4096kB = 9988kB
Normal: 128*4kB 1*8kB 1*16kB 4*32kB 5*64kB 2*128kB 3*256kB 0*512kB 0*1024kB 0*2048kB 0*4096kB = 2008kB
11111 total pagecache pages
10625 pages in swap cache
Swap cache stats: add 2145630, delete 2135005, find 16368/21648
Free swap  = 0kB
Total swap = 8388604kB
1048560 pages RAM
34200 pages reserved
3449 pages shared
1004350 pages non-shared
[ pid ]   uid  tgid total_vm      rss cpu oom_adj oom_score_adj name
[11313]     0 11313     3178        1   0     -17         -1000 udevd
[12094]     0 12094     1747       18   0       0             0 irqbalance
[12383]     0 12383     5997        0   0       0             0 syslog-ng
[12384]     0 12384     7675       59   1       0             0 syslog-ng
[12414]     0 12414      975        1   0       0             0 acpid
[12439]   103 12439     5066      162   0       0             0 dbus-daemon
[12452]     0 12452    30632        0   0       0             0 console-kit-dae
[12530]     0 12530    32851        0   1       0             0 polkitd
[12547]     1 12547     1489        0   0       0             0 portmap
[12562] 65534 12562     2021        2   0       0             0 rpc.statd
[12575]     0 12575    39047        5   1       0             0 cupsd
[12597]     0 12597     3101       20   1       0             0 rpc.mountd
[12627]   124 12627     8484        0   0       0             0 avahi-daemon
[12628]   124 12628     8453        0   0       0             0 avahi-daemon
[12657]     0 12657     1632        4   0       0             0 gpm
[12687]     0 12687    34876        4   0       0             0 gdm
[12689]     0 12689    42035        5   0       0             0 gdm-simple-slav
[12700]     0 12700    39689      273   1       0             0 Xorg
[12709]    60 12709    61127      832   0       0             0 mysqld
[12914]     0 12914     7302        3   0     -17         -1000 sshd
[12947]     0 12947    91462       23   0       0             0 apache2
[12968]    81 12968   156537        0   1       0             0 apache2
[12981]    81 12981   172896        0   1       0             0 apache2
[13072]     0 13072    44010        5   1       0             0 gdm-session-wor
[13077]     0 13077    30068      107   1       0             0 upowerd
[13150]   105 13150    49981      940   0       0             0 clamd
[13156]   105 13156    12745        4   1       0             0 freshclam
[13170]     0 13170      969        0   1       0             0 courierlogger
[13171]     0 13171     8285        5   0       0             0 authdaemond
[13182]     0 13182     8838      100   1       0             0 authdaemond
[13183]     0 13183     8838       73   0       0             0 authdaemond
[13184]     0 13184     8838       90   0       0             0 authdaemond
[13185]     0 13185     8838       84   0       0             0 authdaemond
[13186]     0 13186     8838       96   0       0             0 authdaemond
[13228]     8 13228      968        1   1       0             0 courierfilter
[13230]     8 13230      936        0   0       0             0 courierlogger
[13237]     0 13237      969        0   0       0             0 courierlogger
[13238]     0 13238     5106        2   0       0             0 sqwebmaild
[13242]     0 13242     5106        0   0       0             0 sqwebmaild
[13244]     0 13244     5106        0   0       0             0 sqwebmaild
[13246]     0 13246     5106        0   0       0             0 sqwebmaild
[13248]     0 13248     5106        0   0       0             0 sqwebmaild
[13250]     0 13250     5106        0   0       0             0 sqwebmaild
[13260]     0 13260     5308        1   0       0             0 courierd
[13274]     8 13274     3599       12   0       0             0 couriertcpd
[13279]     8 13279      969       15   0       0             0 courierlogger
[13284]     8 13284     3599        0   1       0             0 couriertcpd
[13287]     8 13287      936        0   1       0             0 courierlogger
[13292]     8 13292     3599        0   1       0             0 couriertcpd
[13294]     8 13294      969        4   1       0             0 courierlogger
[13300]     0 13300      969        0   1       0             0 courierlogger
[13301]     0 13301     2020        0   0       0             0 couriertcpd
[13306]     0 13306      969        0   1       0             0 courierlogger
[13307]     0 13307     2020        0   0       0             0 couriertcpd
[13313]     0 13313      969        0   0       0             0 courierlogger
[13314]     0 13314     2020        0   1       0             0 couriertcpd
[13320]     0 13320      969        3   1       0             0 courierlogger
[13321]     0 13321     2020        2   0       0             0 couriertcpd
[13341]     0 13341      971        5   1       0             0 cpudynd
[13360]     0 13360     4698        1   1       0             0 fcron
[13375]   104 13375    10579      254   0       0             0 hald
[13376]     0 13376     5035        5   0       0             0 hald-runner
[13405]     0 13405     5566        0   1       0             0 hald-addon-inpu
[13426]     0 13426     3908       17   0       0             0 hald-addon-hid-
[13428]     0 13428     5566       32   0       0             0 hald-addon-stor
[13429]     0 13429     5566       33   0       0             0 hald-addon-stor
[13431]     0 13431     5566       30   0       0             0 hald-addon-stor
[13432]     0 13432     5566       31   0       0             0 hald-addon-stor
[13433]     0 13433     5568        0   0       0             0 hald-addon-cpuf
[13434]   104 13434     6012        2   0       0             0 hald-addon-acpi
[13438]     0 13438     5566       19   0       0             0 hald-addon-stor
[13440]     0 13440     5566       31   0       0             0 hald-addon-stor
[13476]     0 13476     5351       28   0       0             0 ntpd
[13490]     0 13490    41726        8   1       0             0 smbd
[13495]     0 13495    41726        0   1       0             0 smbd
[13496]     0 13496    34115       30   1       0             0 nmbd
[13511]  1000 13511    20338        5   0       0             0 gnome-keyring-d
[13522]     0 13522     3007        2   0       0             0 smartd
[13532]  1000 13532    89991      105   0       0             0 gnome-session
[13557]  1000 13557     6536        0   1       0             0 dbus-launch
[13558]  1000 13558     5176      130   0       0             0 dbus-daemon
[13559]  1000 13559     2978        4   0       0             0 ssh-agent
[13564]  1000 13564    37469      167   0       0             0 gconfd-2
[13586]  1000 13586   125461      160   0       0             0 gnome-settings-
[13589]  1000 13589    34676        0   0       0             0 gvfsd
[13594]  1000 13594   129564      634   1       0             0 metacity
[13598]  1000 13598   172572     1692   0       0             0 gnome-panel
[13601]     0 13601    63598      902   0       0             0 spamd
[13602]  1000 13602   189093      671   1       0             0 nautilus
[13604]  1000 13604    63245        8   1       0             0 gvfs-gdu-volume
[13606]     0 13606    32819        9   1       0             0 udisks-daemon
[13608]  1000 13608    44921        0   0       0             0 bonobo-activati
[13609]  1000 13609   150425     1572   0       0             0 pidgin
[13610]     0 13610    10081       28   0       0             0 udisks-daemon
[13617]  1000 13617    86635      160   0       0             0 gnome-power-man
[13618]  1000 13618    90436        0   1       0             0 gdu-notificatio
[13620]  1000 13620   118380        0   0       0             0 evolution-alarm
[13623]  1000 13623    67525        0   0       0             0 polkit-gnome-au
[13627]  1000 13627    94038      309   0       0             0 gnome-screensav
[13638]  1000 13638   105594        0   0       0             0 drivemount_appl
[13640]  1000 13640   112837        0   0       0             0 mixer_applet2
[13642]  1000 13642    36344        5   0       0             0 gvfsd-trash
[13650]  1000 13650   112911        0   1       0             0 e-calendar-fact
[13655]     0 13655    28586        0   1       0             0 system-tools-ba
[13667]  1000 13667    34650        2   0       0             0 gvfsd-burn
[13671]  1000 13671    64040        0   0       0             0 e-addressbook-f
[13683]  1000 13683    33332        3   1       0             0 gvfsd-metadata
[13701]     0 13701    14244        0   0       0             0 SystemToolsBack
[13842]     8 13842    66389     7893   0       0             0 spamd
[13845]     8 13845    64710     7412   0       0             0 spamd
[13857]     0 13857    26919        0   1       0             0 system-tools-ba
[13872]   122 13872    44611        5   1       0             0 timidity
[13907]     0 13907     4835        0   0       0             0 xinetd
[13922]     0 13922     2549        3   0       0             0 agetty
[13923]     0 13923     2549        3   1       0             0 agetty
[13924]     0 13924     2549        3   0       0             0 agetty
[13925]     0 13925     2549        3   0       0             0 agetty
[13926]     0 13926     2549        3   1       0             0 agetty
[13927]     0 13927     2549        3   0       0             0 agetty
[13952]  1000 13952   146604     1301   0       0             0 linphone-3
[14030]  1000 14030    63668        0   1       0             0 gvfsd-http
[16679]  1000 16679   113103      737   1       0             0 notification-da
[ 2314]     0  2314    10441        7   0       0             0 apcupsd
[ 4218]     0  4218     3177        0   1     -17         -1000 udevd
[ 4219]     0  4219     3177        0   0     -17         -1000 udevd
[ 4229]     0  4229     5566       34   0       0             0 hald-addon-stor
[ 5718]     8  5718     5377       20   1       0             0 courierd
[ 5719]    10  5719     4420        0   1       0             0 courieruucp
[ 5720]     0  5720      977        5   0       0             0 courierlocal
[ 5721]     0  5721     1800        0   1       0             0 courierfax
[ 5722]     8  5722     3896        0   0       0             0 courieresmtp
[ 5723]     8  5723      976        0   1       0             0 courierdsn
[ 5724]  1000  5724  2890943   921372   0       0             0 gltext
Out of memory: Kill process 5724 (gltext) score 923 or sacrifice child
Killed process 5724 (gltext) total-vm:11563772kB, anon-rss:3682188kB, file-rss:3300kB
Comment 1 Mamoru TASAKA 2011-01-11 05:14:52 UTC
On Fedora:
http://pkgs.fedoraproject.org/gitweb/?p=xscreensaver.git;a=commitdiff;h=32e89dc222df24a357f296e79bea1ffbab6d3477

The patch was accepted by Jamie on 2010-10-16
Comment 2 Samuli Suominen gentoo-dev 2011-01-13 11:35:00 UTC
+*xscreensaver-5.12-r1 (13 Jan 2011)
+
+  13 Jan 2011; Samuli Suominen <ssuominen@gentoo.org>
+  +xscreensaver-5.12-r1.ebuild,
+  +files/xscreensaver-5.12-for-now-set-lang-on-daemon-to-C.patch,
+  +files/xscreensaver-5.12-gltext-memleak.patch:
+  Fix password string display wrt #349512 by Sergey and Mamoru Tasaka. Fix
+  gtkext memory leak wrt #351173 by Brian Beardall and Mamoru Tasaka.